<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>DUNE Warm Interface Board: /home/dan/work/DUNE/dune-wib.firmware/trunk/src/DTS/ProtoDUNE_TimingSystem/pdts_ep_startup.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">DUNE Warm Interface Board
   </div>
   <div id="projectbrief">Firmware for the DUNE Warm Interface Board (WIB)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_d5f2f5bed3199c43277086728111e9c9.html">DTS</a></li><li class="navelem"><a class="el" href="dir_90267f26e899dc7372f7f3f7704d6d52.html">ProtoDUNE_TimingSystem</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">pdts_ep_startup.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="keyword">-- pdts_ep_startup</span><span class="keyword"></span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">-- The timing endpoint design</span><span class="keyword"></span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">-- Dave Newbold, February </span><span class="vhdllogic">2017</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="vhdlkeyword">library </span><span class="keywordflow">IEEE</span>;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="vhdlkeyword">use </span>IEEE.STD_LOGIC_1164.<span class="vhdlkeyword">ALL</span>;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="vhdlkeyword">use </span>ieee.numeric_std.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="vhdlkeyword">use </span>ieee.std_logic_misc.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classpdts__defs.html">pdts_defs</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno"><a class="code" href="classpdts__ep__startup.html">   14</a></span>&#160;<span class="keywordflow">entity </span><a class="code" href="classpdts__ep__startup.html">pdts_ep_startup</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    <span class="vhdlkeyword">generic</span><span class="vhdlchar">(</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        <span class="vhdlchar">SCLK_FREQ</span><span class="vhdlchar">:</span> <span class="comment">real</span>;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="vhdlchar">SIM</span><span class="vhdlchar">:</span> <span class="comment">boolean</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">false</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="vhdlkeyword">port</span><span class="vhdlchar">(</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="vhdlchar">sclk</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- Free-running system clock</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <span class="vhdlchar">srst</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- System reset (sclk domain)</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="vhdlchar">stat</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;<span class="keyword"> -- Status output (sclk domain)</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        <span class="vhdlchar">sfp_los</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- SFP LOS line (async, sampled <span class="vhdlkeyword">in</span> sclk domain)</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        <span class="vhdlchar">cdr_los</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- CDR LOS line (asnc, sampled <span class="vhdlkeyword">in</span> sclk domain)</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="vhdlchar">cdr_lol</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- CDR LOL line (async, sampled <span class="vhdlkeyword">in</span> sclk domain)</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        <span class="vhdlchar">rec_clk</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- CDR recovered clock</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="vhdlchar">rec_rst</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;<span class="keyword"> -- Reset <span class="vhdlkeyword">out</span> (rec_clk domain)</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="vhdlchar">rxphy_aligned</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- RX phy <span class="vhdlkeyword">is</span> aligned</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="vhdlchar">clk</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- 50MHz clock input</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="vhdlchar">rxphy_rst</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;<span class="keyword"> -- RX phy reset</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="vhdlchar">rxphy_locked</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- RX phy locked</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="vhdlchar">rst</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;<span class="keyword"> -- 50MHz reset</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <span class="vhdlchar">rx_err</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">2</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;<span class="keyword"> -- RX decoder error status </span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="vhdlchar">rdy</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span><span class="keyword"> -- Timestamp ready</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlchar">pdts_ep_startup</span>;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="code" href="classpdts__ep__startup_1_1rtl.html">   39</a></span>&#160;<span class="vhdlkeyword">architecture</span> rtl <span class="vhdlkeyword">of</span> <a class="code" href="classpdts__ep__startup.html">pdts_ep_startup</a> is</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="vhdlkeyword">type</span> <span class="vhdlchar">state_t</span> <span class="vhdlkeyword">is</span> <span class="vhdlchar">(</span><span class="vhdlchar">W_RST</span><span class="vhdlchar">,</span> <span class="vhdlchar">W_SFP</span><span class="vhdlchar">,</span> <span class="vhdlchar">W_CDR</span><span class="vhdlchar">,</span> <span class="vhdlchar">W_FREQ</span><span class="vhdlchar">,</span> <span class="vhdlchar">W_ALIGN</span><span class="vhdlchar">,</span> <span class="vhdlchar">W_LOCK</span><span class="vhdlchar">,</span> <span class="vhdlchar">W_RDY</span><span class="vhdlchar">,</span> <span class="vhdlchar">RUN</span><span class="vhdlchar">,</span> <span class="vhdlchar">ERR_R</span><span class="vhdlchar">,</span> <span class="vhdlchar">ERR_T</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">state</span><span class="vhdlchar">,</span> <span class="vhdlchar">state_d</span><span class="vhdlchar">:</span> <span class="vhdlchar">state_t</span>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">rctr</span><span class="vhdlchar">:</span> <span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">4</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">f_ok</span><span class="vhdlchar">,</span> <span class="vhdlchar">t</span><span class="vhdlchar">,</span> <span class="vhdlchar">td</span><span class="vhdlchar">:</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">sctr</span><span class="vhdlchar">,</span> <span class="vhdlchar">cctr</span><span class="vhdlchar">,</span> <span class="vhdlchar">cctr_rnd</span><span class="vhdlchar">:</span> <span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">sfp_los_ctr</span><span class="vhdlchar">,</span> <span class="vhdlchar">cdr_ctr</span><span class="vhdlchar">:</span> <span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">sfp_los_ok</span><span class="vhdlchar">,</span> <span class="vhdlchar">cdr_ok</span><span class="vhdlchar">:</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">rxphy_aligned_i</span><span class="vhdlchar">,</span> <span class="vhdlchar">rxphy_locked_i</span><span class="vhdlchar">,</span> <span class="vhdlchar">rx_err_f</span><span class="vhdlchar">,</span> <span class="vhdlchar">rx_err_i</span><span class="vhdlchar">,</span> <span class="vhdlchar">rdy_i</span><span class="vhdlchar">:</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">rec_rst_i</span><span class="vhdlchar">,</span> <span class="vhdlchar">rxphy_rst_i</span><span class="vhdlchar">,</span> <span class="vhdlchar">rst_i</span><span class="vhdlchar">,</span> <span class="vhdlchar">rst_u</span><span class="vhdlchar">:</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="vhdlkeyword">begin</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="vhdlkeyword">process</span>(sclk)</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="vhdlkeyword">    begin</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="vhdlkeyword">if</span> <span class="vhdlchar">rising_edge</span><span class="vhdlchar">(</span><span class="vhdlchar">sclk</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            <span class="vhdlkeyword">if</span> <span class="vhdlchar">srst</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;                <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_RST</span>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            <span class="vhdlkeyword">else</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;                <span class="vhdlkeyword">case</span> <span class="vhdlchar">state</span> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;                <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_RST</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;                    <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_SFP</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keyword">-- Startup; <span class="vhdlkeyword">wait</span> <span class="vhdlkeyword">for</span> SFP <span class="vhdlkeyword">signal</span></span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;                <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_SFP</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;                    <span class="vhdlkeyword">if</span> <span class="vhdlchar">sfp_los_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_CDR</span>;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;                    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">Wait</span> <span class="vhdlkeyword">for</span> CDR lock</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;                <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_CDR</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;                    <span class="vhdlkeyword">if</span> <span class="vhdlchar">cdr_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_ALIGN</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;                    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">Wait</span> <span class="vhdlkeyword">for</span> rxphy alignment</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;                <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_ALIGN</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;                    <span class="vhdlkeyword">if</span> <span class="vhdlchar">sfp_los_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">cdr_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_SFP</span>;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;                    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">rxphy_aligned_i</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_FREQ</span>;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;                    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">Wait</span> <span class="vhdlkeyword">for</span> frequency match</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;                <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_FREQ</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;                    <span class="vhdlkeyword">if</span> <span class="vhdlchar">sfp_los_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">cdr_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_SFP</span>;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;                    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">f_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">SIM</span> <span class="vhdlkeyword">then</span><span class="keyword"> -- Don&#39;t want simulation <span class="vhdlkeyword">to</span> <span class="vhdlkeyword">wait</span> <span class="vhdlkeyword">for</span> freq lock</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_LOCK</span>;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;                    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;                <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_LOCK</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">Wait</span> <span class="vhdlkeyword">for</span> rxphy lock</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;                <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_LOCK</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;                    <span class="vhdlkeyword">if</span> <span class="vhdlchar">sfp_los_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">cdr_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_SFP</span>;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;                    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">rxphy_locked_i</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_RDY</span>;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;                    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">Wait</span> <span class="vhdlkeyword">for</span> ready flag</span></div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;                <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_RDY</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;                    <span class="vhdlkeyword">if</span> <span class="vhdlchar">sfp_los_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">cdr_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_SFP</span>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;                    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">rxphy_locked_i</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_ALIGN</span>;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;                    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">rx_err_i</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">ERR_R</span>;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;                    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">rdy_i</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">RUN</span>;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;                    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="keyword">-- Running state</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;                <span class="vhdlkeyword">when</span> <span class="vhdlchar">RUN</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;                    <span class="vhdlkeyword">if</span> <span class="vhdlchar">sfp_los_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">cdr_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_SFP</span>;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;                    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">rxphy_locked_i</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">W_ALIGN</span>;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;                    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">rx_err_i</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">ERR_R</span>;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;                    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">rdy_i</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;                        <span class="vhdlchar">state</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">ERR_T</span>;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;                    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="keyword">-- Error stats. Doomed.</span></div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;                <span class="vhdlkeyword">when</span> <span class="vhdlchar">ERR_R</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;                <span class="vhdlkeyword">when</span> <span class="vhdlchar">ERR_T</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;                <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">case</span>;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span>;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="keyword">-- Freq check</span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="vhdlkeyword">process</span>(clk)<span class="keyword"> -- Predivide by </span><span class="vhdllogic">32</span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="vhdlkeyword">    begin</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        <span class="vhdlkeyword">if</span> <span class="vhdlchar">rising_edge</span><span class="vhdlchar">(</span><span class="vhdlchar">clk</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;            <span class="vhdlkeyword">if</span> <span class="vhdlchar">rxphy_locked</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;                <span class="vhdlchar">rctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;            <span class="vhdlkeyword">else</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;                <span class="vhdlchar">rctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">rctr</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span>;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    sync_t: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classpdts__synchro.html">pdts_synchro</a></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        <span class="vhdlkeyword">generic</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;            N  =&gt; <span class="vhdllogic">1</span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="vhdlchar">)</span></div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;            clk  =&gt; clk,</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;            clks  =&gt; sclk,</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;            d<span class="vhdlchar">(</span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  =&gt; rctr<span class="vhdlchar">(</span><span class="vhdllogic">4</span><span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;            q<span class="vhdlchar">(</span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  =&gt; t</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <span class="vhdlkeyword">process</span>(sclk)</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="vhdlkeyword">    begin</span></div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        <span class="vhdlkeyword">if</span> <span class="vhdlchar">rising_edge</span><span class="vhdlchar">(</span><span class="vhdlchar">sclk</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            <span class="vhdlchar">td</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">t</span>;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            <span class="vhdlkeyword">if</span> <span class="vhdlchar">srst</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;                <span class="vhdlchar">sctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;                <span class="vhdlchar">cctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;                <span class="vhdlchar">f_ok</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            <span class="vhdlkeyword">else</span></div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;                <span class="vhdlchar">sctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">sctr</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;                <span class="vhdlkeyword">if</span> <span class="vhdlchar">sctr</span> <span class="vhdlchar">=</span> <span class="vhdlchar">X</span><span class="keyword">&quot;ffff&quot;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;                    <span class="vhdlkeyword">if</span> <span class="vhdlchar">cctr_rnd</span> <span class="vhdlchar">=</span> <span class="vhdlchar">to_unsigned</span><span class="vhdlchar">(</span><span class="comment">integer</span><span class="vhdlchar">(</span><span class="vhdlchar">(</span><span class="vhdlchar">CLK_FREQ</span> <span class="vhdlchar">/</span> <span class="vhdlchar">SCLK_FREQ</span><span class="vhdlchar">)</span> <span class="vhdlchar">*</span> <span class="vhdllogic"></span><span class="vhdllogic">2048</span>.<span class="vhdllogic">0</span><span class="vhdlchar">)</span><span class="vhdlchar">,</span> <span class="vhdllogic"></span><span class="vhdllogic">16</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;                        <span class="vhdlchar">f_ok</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;                    <span class="vhdlkeyword">else</span></div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;                        <span class="vhdlchar">f_ok</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;                    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;                    <span class="vhdlchar">cctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;                <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">t</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">td</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;                    <span class="vhdlchar">cctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">cctr</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;                <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span>;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    </div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    <span class="vhdlchar">cctr_rnd</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">cctr</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">t</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">else</span> <span class="vhdlchar">cctr</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="keyword">-- External <span class="vhdlkeyword">signal</span> debounce </span></div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    <span class="vhdlkeyword">process</span>(sclk)</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="vhdlkeyword">    begin</span></div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        <span class="vhdlkeyword">if</span> <span class="vhdlchar">rising_edge</span><span class="vhdlchar">(</span><span class="vhdlchar">sclk</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;            <span class="vhdlkeyword">if</span> <span class="vhdlchar">srst</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;                <span class="vhdlchar">sfp_los_ctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;                <span class="vhdlchar">cdr_ctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;            <span class="vhdlkeyword">else</span></div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;                <span class="vhdlkeyword">if</span> <span class="vhdlchar">sfp_los</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;                    <span class="vhdlchar">sfp_los_ctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;                <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">sfp_los_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;                    <span class="vhdlchar">sfp_los_ctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">sfp_los_ctr</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;                <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;                <span class="vhdlkeyword">if</span> <span class="vhdlchar">cdr_los</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">cdr_lol</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                    <span class="vhdlchar">cdr_ctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;                <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">cdr_ok</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;                    <span class="vhdlchar">cdr_ctr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">cdr_ctr</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;                <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span>;</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    <span class="vhdlchar">sfp_los_ok</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">and_reduce</span><span class="vhdlchar">(</span><span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">sfp_los_ctr</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    <span class="vhdlchar">cdr_ok</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">and_reduce</span><span class="vhdlchar">(</span><span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">cdr_ctr</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="keyword">-- CDC into sclk domain</span></div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <span class="vhdlkeyword">process</span>(clk)</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;<span class="vhdlkeyword">    begin</span></div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="vhdlkeyword">if</span> <span class="vhdlchar">rising_edge</span><span class="vhdlchar">(</span><span class="vhdlchar">clk</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;            <span class="vhdlkeyword">if</span> <span class="vhdlchar">rst_u</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;                <span class="vhdlchar">rx_err_f</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;            <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">rx_err</span> <span class="vhdlchar">/=</span> <span class="vhdllogic">&quot;000&quot;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;                <span class="vhdlchar">rx_err_f</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span>;</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    sync_sclk: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classpdts__synchro.html">pdts_synchro</a></div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;        <span class="vhdlkeyword">generic</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;            N  =&gt; <span class="vhdllogic">4</span></div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        <span class="vhdlchar">)</span></div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;            clk  =&gt; clk,</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;            clks  =&gt; sclk,</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;            d<span class="vhdlchar">(</span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  =&gt; rxphy_aligned,</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;            d<span class="vhdlchar">(</span><span class="vhdllogic">1</span><span class="vhdlchar">)</span>  =&gt; rxphy_locked,</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;            d<span class="vhdlchar">(</span><span class="vhdllogic">2</span><span class="vhdlchar">)</span>  =&gt; rx_err_f,</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;            d<span class="vhdlchar">(</span><span class="vhdllogic">3</span><span class="vhdlchar">)</span>  =&gt; rdy,</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;            q<span class="vhdlchar">(</span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  =&gt; rxphy_aligned_i,</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;            q<span class="vhdlchar">(</span><span class="vhdllogic">1</span><span class="vhdlchar">)</span>  =&gt; rxphy_locked_i,</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;            q<span class="vhdlchar">(</span><span class="vhdllogic">2</span><span class="vhdlchar">)</span>  =&gt; rx_err_i,</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;            q<span class="vhdlchar">(</span><span class="vhdllogic">3</span><span class="vhdlchar">)</span>  =&gt; rdy_i</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;<span class="keyword">-- Resets</span></div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    <span class="vhdlchar">rec_rst_i</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">state</span> <span class="vhdlchar">=</span> <span class="vhdlchar">W_RST</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">state</span> <span class="vhdlchar">=</span> <span class="vhdlchar">W_SFP</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">state</span> <span class="vhdlchar">=</span> <span class="vhdlchar">W_CDR</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">state</span> <span class="vhdlchar">=</span> <span class="vhdlchar">W_FREQ</span> <span class="vhdlkeyword">else</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    <span class="vhdlchar">rxphy_rst_i</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">rec_rst_i</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">state</span> <span class="vhdlchar">=</span> <span class="vhdlchar">W_ALIGN</span> <span class="vhdlkeyword">else</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    <span class="vhdlchar">rst_i</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">rxphy_rst_i</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">state</span> <span class="vhdlchar">=</span> <span class="vhdlchar">W_LOCK</span> <span class="vhdlkeyword">else</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;<span class="keyword">-- CDC into rec_clk / clk domain</span></div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    sync_rec_clk: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classpdts__synchro.html">pdts_synchro</a></div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;            clk  =&gt; sclk,</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;            clks  =&gt; rec_clk,</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;            d<span class="vhdlchar">(</span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  =&gt; rec_rst_i,</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            q<span class="vhdlchar">(</span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  =&gt; rec_rst</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        </div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;    sync_clk: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classpdts__synchro.html">pdts_synchro</a></div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        <span class="vhdlkeyword">generic</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;            N  =&gt; <span class="vhdllogic">2</span></div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        <span class="vhdlchar">)</span></div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;            clk  =&gt; sclk,</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;            clks  =&gt; clk,</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;            d<span class="vhdlchar">(</span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  =&gt; rxphy_rst_i,</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;            d<span class="vhdlchar">(</span><span class="vhdllogic">1</span><span class="vhdlchar">)</span>  =&gt; rst_i,</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;            q<span class="vhdlchar">(</span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  =&gt; rxphy_rst,</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            q<span class="vhdlchar">(</span><span class="vhdllogic">1</span><span class="vhdlchar">)</span>  =&gt; rst_u</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        </div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;    <span class="vhdlchar">rst</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">rst_u</span>;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;<span class="keyword">-- State output</span></div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    <span class="vhdlkeyword">with</span> <span class="vhdlchar">state</span> <span class="vhdlkeyword">select</span> <span class="vhdlchar">stat</span> <span class="vhdlchar">&lt;=</span></div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        <span class="vhdllogic">&quot;0000&quot;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_RST</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        <span class="vhdllogic">&quot;0001&quot;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_SFP</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;        <span class="vhdllogic">&quot;0010&quot;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_CDR</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        <span class="vhdllogic">&quot;0011&quot;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_ALIGN</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        <span class="vhdllogic">&quot;0100&quot;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_FREQ</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        <span class="vhdllogic">&quot;0101&quot;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_LOCK</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        <span class="vhdllogic">&quot;0110&quot;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">W_RDY</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        <span class="vhdllogic">&quot;1000&quot;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">RUN</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        <span class="vhdllogic">&quot;1100&quot;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">ERR_R</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        <span class="vhdllogic">&quot;1101&quot;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">ERR_T</span>;</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlchar">rtl</span>;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Nov 1 2017 10:40:30 for DUNE Warm Interface Board by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
